/*--------------------------------------------------------------------------
 *  Copyright 2011 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ
//
// GlobalCommandOption.java
// Since: 2011/03/22 17:55:18
//
// $URL$
// $Author$
//--------------------------------------
package org.xerial.util.opt;

/**
 * Global option of the command launcher. Extend this class to add your own
 * global command-line options.
 * 
 * @see CommandLauncher#setMessage(CommandHelpMessage)
 * 
 * @author leo
 * 
 */
public class GlobalCommandOption {
    @Argument(index = 0)
    public String command;
    @Option(symbol = "h", longName = "help", description = "display help messages")
    public boolean displayHelp = false;
}
