/*--------------------------------------------------------------------------
 *  Copyright 2009 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// Xerial Raquel Project
//
// SchemaTest.java
// Since: 2009/03/14 16:53:43
//
// $URL$
// $Author$
//--------------------------------------
package org.xerial.lens.relation.schema;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.xerial.util.FileResource;
import org.xerial.util.log.Logger;

public class SchemaSetTest {

    private static Logger _logger = Logger.getLogger(SchemaSetTest.class);

    @Before
    public void setUp() throws Exception {}

    @After
    public void tearDown() throws Exception {}

    @Test
    public void test() throws Exception {
        RelationSchema userSchema = RelationSchema.parse(FileResource.open(SchemaSetTest.class,
                "sample.schema"));
        _logger.debug(userSchema.toString());
        SchemaSet schema = new SchemaSet(userSchema);
    }

    @Test
    public void testXMark() throws Exception {
        RelationSchema userSchema = RelationSchema.parse(FileResource.open(SchemaSetTest.class,
                "xmark.schema"));
        _logger.debug(userSchema.toString());
        SchemaSet schema = new SchemaSet(userSchema);
    }

}
